using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.PositiveAdjustment.Cqrs;

public record DeletePositiveAdjustmentItemCommand(string Id) : IRequest<bool>;

public class DeletePositiveAdjustmentItemHandler : IRequestHandler<DeletePositiveAdjustmentItemCommand, bool>
{
    private readonly AppDbContext _context;
    public DeletePositiveAdjustmentItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeletePositiveAdjustmentItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.InventoryTransaction.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}